/**************************************************************************

  SC1602 Liquid Crystal Display
  16 x 2 Charactor Display LCD
  DRIVER IC: HD44780

  MaiaR create

 **************************************************************************/

#include <LiquidCrystal.h>
#include "LoRa.h"

#define RS 6
#define EN 4
#define DB4 25
#define DB5 2
#define DB6 3
#define DB7 5

LiquidCrystal lcd(RS, EN, DB4, DB5, DB6, DB7);

void setup(void) {
  lcd.begin(16, 2);
  lcd.clear();
  lcd.print("LoRa Display");
  lcd.setCursor(0, 1);
  lcd.print("Stand-by");
  LoRaInit();
}

void loop() {
  if (Serial1.available() > 0) {
    String rxs = Serial1.readString();
    Serial.print(rxs);
    char Buf[5];
    rxs.toCharArray(Buf, 5);
    int16_t rssi = strtol(Buf,NULL,16);
    rxs = rxs.substring(4);
    lcd.clear();
    
    lcd.print("\xFF");
    lcd.print(" " + rxs.substring( 2, 6 ));
    lcd.print(" " + rxs.substring( 8,12 ));
    if (rxs.length() > 16){
      lcd.print(" " + rxs.substring(14,18 ) + " ");
    }

    lcd.setCursor(0, 1);
    lcd.print("R: ");
    lcd.print(rssi);
    lcd.print(" dBm");

    delay(800);
    lcd.setCursor(0, 0);
    lcd.print(" ");
  }
}
